package io.gitlab.jfronny.muscript.ast.dynamic;

import io.gitlab.jfronny.muscript.ast.DynamicExpr;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.data.dynamic.DFinal;
import io.gitlab.jfronny.muscript.data.dynamic.Dynamic;

import java.util.LinkedList;
import java.util.List;

public class Bind extends DynamicExpr {
    public final DynamicExpr callable;
    public final DynamicExpr parameter;

    public Bind(int chStart, int chEnd, DynamicExpr callable, DynamicExpr parameter) {
        super(chStart, chEnd);
        this.callable = callable;
        this.parameter = parameter;
    }

    @Override
    public Dynamic<?> get(Scope dataRoot) {
        return DFinal.of(args -> {
            List<Dynamic<?>> argsWithParameter = new LinkedList<>(args.getValue());
            argsWithParameter.add(0, parameter.get(dataRoot));
            return callable.get(dataRoot)
                    .asCallable()
                    .getValue()
                    .apply(DFinal.of(argsWithParameter));
        });
    }

    @Override
    public DynamicExpr optimize() {
        return new Bind(chStart, chEnd, callable.optimize(), parameter.optimize());
    }
}
