package io.gitlab.jfronny.muscript.test;

import io.gitlab.jfronny.muscript.compiler.Parser;
import org.junit.jupiter.api.Test;

import static io.gitlab.jfronny.muscript.test.util.MuTestUtil.makeArgs;
import static org.junit.jupiter.api.Assertions.assertEquals;

class CommentTest {
    @Test
    void singleLine() {
        assertEquals(2, Parser.parseScript("""
                n = 5
                n = 2
                // n = 3
                n
                """).run(makeArgs()).asNumber().getValue());
    }

    @Test
    void multiLine() {
        assertEquals(2, Parser.parseScript("""
                n = 2
                /* n = 3 */
                /*
                  n = 3
                  n = 4
                  n = 5
                */
                n
                """).run(makeArgs()).asNumber().getValue());
    }
}
